#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_skill.h"
std::auto_ptr<M_skill> M_skill::msSingleton(nullptr);

int M_skill::GetCount()
{
	return (int)mMapData.size();
}

const M_skillData* M_skill::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_skillData>& M_skill::GetMapData()
{
	return mMapData;
}

void M_skill::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_skill.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_skillData data;
		data.mID = element->IntAttribute("ID");
		data.mhero_id = element->IntAttribute("hero_id");
		data.mskill_leve = element->IntAttribute("skill_leve");
		data.mbullet_num = element->IntAttribute("bullet_num");
		data.mbullet_radius = element->IntAttribute("bullet_radius");
		data.mattack_distance = element->IntAttribute("attack_distance");
		data.mskill_des = element->Attribute("skill_des");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_skill Loaded. Load Data:%u", mMapData.size());
}

void M_skill::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_skill");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_skill");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_skillData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "hero_id", data.mhero_id);
		LuaCfgHelper::readInt(L, "skill_leve", data.mskill_leve);
		LuaCfgHelper::readInt(L, "bullet_num", data.mbullet_num);
		LuaCfgHelper::readInt(L, "bullet_radius", data.mbullet_radius);
		LuaCfgHelper::readInt(L, "attack_distance", data.mattack_distance);
		LuaCfgHelper::readString(L, "skill_des", data.mskill_des);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_skill Loaded. Load Data:%u", mMapData.size());
}

void M_skill::Reload()
{
	mMapData.clear();
	Load();
}

M_skill* M_skill::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_skill());
	}
	return msSingleton.get();
}

void M_skill::Release()
{
	msSingleton.reset(nullptr);
}
